///////////////////////////////////////////////////////////////////////////////
////  (c) Chaichuk AU (chaichuk@mail.ru), 								   ////
////  2004, Chelyabinsk, NTC Privodnaya Tehnika (momentum@chel.surnet.ru)  ////
///////////////////////////////////////////////////////////////////////////////

/* CwLadder.h - widget header file */
#ifndef __CWLADDER_H_
#define __CWLADDER_H_

#include <Pt.h>
#include <cogent.h>

/* widget resources */

#define Cw_LADDER_ARG_POS			Pt_RESOURCE (Pt_USER (2), 0)
#define Cw_LADDER_SELECT			Pt_RESOURCE (Pt_USER (2), 1)
#define Cw_LADDER_LOAD_FILES		Pt_RESOURCE (Pt_USER (2), 2)
#define Cw_LADDER_LABEL				Pt_RESOURCE (Pt_USER (2), 3)
#define Cw_LADDER_LIST				Pt_RESOURCE (Pt_USER (2), 4)


struct busbar_s;
struct config_s;

/* widget instance structure */
typedef struct cw_ladder_widget{
	PtBasicWidget_t	basic;
	
	PhRect_t		mg;				// отступы
	int				dx;				// расстояние между элементами по горизонтали
	int				dy;				// расстояние между элементами по вертикали	
	int				chars_in_line;	// максимальное кол-во символов в строке	

	int				n_fname;		// кол-во загружаемых файлов
	char			*fname [100];	// имена загружаемых файлов

	int				n_busbar;		// кол-во схем
	int				selected;		// номер выбранной схемы
	struct busbar_s	*busbar;		// схемы

	char			*dev_name;
	IP_Msg			*hmsg;
	IP_Task			*myself;	

	//int				shm_open;		// общая память открыта (1) или нет (0)
	
	PtWidget_t		*list_wgt;
	PtWidget_t		*label_wgt;
	
}	CwLadderWidget_t;

/* widget class pointer */
extern PtWidgetClassRef_t *CwLadder;

#endif //__CWLADDER_H_