///////////////////////////////////////////////////////////////////////////////
////  (c) Chaichuk AU (chaichuk@mail.ru), 								   ////
////  2004, Chelyabinsk, NTC Privodnaya Tehnika (momentum@chel.surnet.ru)  ////
///////////////////////////////////////////////////////////////////////////////

#ifndef __CW_LADDER_PARSER_CJ_H_
#define __CW_LADDER_PARSER_CJ_H_


#define ST_EOF		-1
#define ST_RESET	0
#define ST_DEVICE	1

typedef struct parser_handle_s {
	FILE		*fp;
	char		*fname;
	int			lnum;
	
	char		buffer [BUFSIZ];
	char		*bufptr;
	char		*token;
	int			state;
} parser_handle_t;

typedef enum elemtype_e {
	etContact = 1,
	etCoil,
	etInstr,
	etOther,
} elemtype_t;

struct element_s;
struct rung_s;

typedef struct symbol_s {
	int		type;
	int		subtype;
	char	name [32];
	char	text [32];
	char	comment [255];

	int		mem_type;
	int		channel;
	int 	bitnum;
} symbol_t;	

#define	MAX_N_INPUTS	2

typedef struct element_s {
	elemtype_t 		type;
	int				subtype;
	int				n_inputs;
	char			mnemonic [32];
	
	int				prev [MAX_N_INPUTS][10];	
	int 			n_prev [MAX_N_INPUTS];
	
	int 			paral [10];
	int 			n_paral;
		
	int 			level;
	int				line_pos;
	
	int				next_pos;
	int				prev_pos [MAX_N_INPUTS];
	
	int 			left_vert [MAX_N_INPUTS];
	int				right_vert;
	
	int				inverted;
	int				active;
	int				selected;
	int				out_active;

	symbol_t		arg [4];
	int				n_arg;
} element_t;

typedef struct rung_s {
	struct element_s   	*element;	
	int 				n_element;
	int 				n_level;
	int					n_out_level;
	int					n_cont_level;
	int					n_line_pos;
	int					n_cont_line_pos;
	int					last_in_top_line;
	int					TR [16];
} rung_t;

#define	PARSER_OK							0
#define	PARSER_INVALID_VALUE				1
#define	PARSER_UNKNOWN_TOKEN				2
#define PARSER_PARSE_LOC_SYM				3
#define PARSER_PARSE_GLOB_SYM				4
#define PARSER_PARSE_MNEMONIC				5

typedef struct busbar_s {
	char				*name;
	rung_t	   			*rung;
	int					n_rung;
	symbol_t			*symbol; 
	int					n_symbol;
	int 				status;
	int					max_line_pos;
} busbar_t;	

	
void parser_parse (busbar_t *busbar, const char *fname, const char *name);

#endif //__CW_LADDER_PARSER_CJ_H_